	DECLARE SUB Initialize ()

'$FORM Cars6
'$FORM philer
'$FORM cars1
'$FORM cars4
'$FORM Cars3
'$FORM cars2
'$FORM cars7
'$INCLUDE: 'cars.bi'
	DIM SHARED rhett(0 TO 259) AS INTEGER
	DIM SHARED bkg(14) AS SINGLE
	DIM SHARED rawdata(8) AS SINGLE
	DIM SHARED normal AS STRING * 3, datadiag AS STRING * 3
	DIM SHARED tran(9) AS SINGLE
	DIM SHARED highlim(1 TO 5) AS INTEGER, lowlim(1 TO 5) AS INTEGER
	DIM SHARED rrayop(0 TO 7, 0 TO 4) AS INTEGER
	DIM SHARED b(9, 4096) AS SINGLE
	DIM SHARED bmax(9, 2) AS SINGLE
	DEF FNarcsin (angle) = 180 * ATN(angle / SQR(1 - angle * angle)) / pi
DIM SHARED emface(0 TO 127, 0 TO 15) AS INTEGER

CALL vidcheck
CALL loadfont

cars4.combo1.ADDITEM STR$(632), 0
cars4.combo1.ADDITEM STR$(589), 1
cars4.combo1.ADDITEM STR$(588), 2

philer.text1.text = "cars.rc"
CALL ReadRC
philer.text1.text = "*.*"
CALL Initialize
CALL PioInit    ' Initialize i/o ports

GOTO hodown
carserror:  RESUME NEXT
initerror: ierr = 99: RESUME NEXT
ferror: BEEP: BEEP: BEEP: MSGBOX "Error": CLOSE #1: RESUME hodown
END

hodown:

cars1.SHOW

SUB ADconv (intrup)

'initialize 8255 by sending hex 92 to port hex 30b
'        OUT &H30B, &H92
'
'wait for laser to fire and eoc on all A/D converters
	OUT &H30A, 64: OUT &H30A, 0: OUT &H30A, 64  'reset trigger flip-flop
'        jlow = INP(&H309)
ad1:    IF (INP(&H309) AND 128) = 0 THEN GOTO ad1  'check for eoc on all ADs
'
'accumulate data for specified number of channels
	FOR i = 1 TO 5
	OUT &H30A, 64 + i         'address channel 1 to 5
	jlow = INP(&H308)                       'get lower 8 bits
	jhigh = INP(&H309) AND 15               'get upper 4 bits
	jhigh = jhigh * 256             'shift the 4 bits left by 8 bits
	 rawdata(i) = jhigh + jlow         'make 16 bit integer
	NEXT i
GOTO adcexit
'
intrup = 1: LOCATE 1, 1, 0: PRINT "Interrupt in ADconv. ";
'
adcexit:  ON ERROR GOTO 0

END SUB

SUB ArrayAllot ()
FOR i = 0 TO noarrays
SELECT CASE LEN(cars1.rray(i).text)
CASE 1  'straight channel assignment
rrayop(i, 0) = 1
rrayop(i, 1) = VAL(cars1.rray(i).text)
CASE 3 'single normalization
rrayop(i, 0) = 2
rrayop(i, 1) = VAL(MID$(cars1.rray(i).text, 1, 1))
rrayop(i, 2) = VAL(MID$(cars1.rray(i).text, 3, 1))
CASE 5 'double normalization
rrayop(i, 0) = 3
rrayop(i, 1) = VAL(MID$(cars1.rray(i).text, 1, 1))
rrayop(i, 2) = VAL(MID$(cars1.rray(i).text, 3, 1))
rrayop(i, 3) = VAL(MID$(cars1.rray(i).text, 5, 1))
CASE 7 'triple normalization
rrayop(i, 0) = 4
rrayop(i, 1) = VAL(MID$(cars1.rray(i).text, 1, 1))
rrayop(i, 2) = VAL(MID$(cars1.rray(i).text, 3, 1))
rrayop(i, 3) = VAL(MID$(cars1.rray(i).text, 5, 1))
rrayop(i, 4) = VAL(MID$(cars1.rray(i).text, 7, 1))


CASE 4       'special array loading
rrayop(i, 0) = -1
SELECT CASE UCASE$(cars1.rray(i).text)
CASE "WAVE"
rrayop(i, 1) = 1
CASE "RAMN"
rrayop(i, 1) = 2
CASE "WVNO"
rrayop(i, 1) = 3
CASE "TIME"
rrayop(i, 1) = 4
CASE ELSE
'NEEDS WORK TRAP ERRONEOUS INPUT
END SELECT

CASE ELSE
'NEEDS WORK TRAP ERRONEOUS INPUT
END SELECT
NEXT i

END SUB

SUB DataRead ()
ON ERROR GOTO ferror
IF RIGHT$(philer.dir1.path, 1) <> "\" THEN txt1$ = "\" ELSE txt1$ = ""
'f$ = philer.dir1.path + txt1$ + philer.text1.text
OPEN philer.dir1.path + txt1$ + philer.text1.text FOR INPUT AS #1
INPUT #1, a$
IF a$ <> "GRAPH 4" THEN GOTO drend
INPUT #1, a$
IF a$ <> "ASCII" THEN GOTO drend
INPUT #1, a$
INPUT #1, a$
INPUT #1, a$: cars1.rray(10).text = STR$(VAL(a$) - 1)
FOR i = 0 TO VAL(cars1.rray(10).text)
INPUT #1, a$
cars1.rray(i).text = a$
NEXT i

a$ = ""
FOR i = 0 TO VAL(cars1.rray(10).text)
INPUT #1, a$
NEXT i
nopoints = VAL(a$)

FOR j = 1 TO nopoints
a$ = ""
FOR i = 0 TO VAL(cars1.rray(10).text)
INPUT #1, a$
b(i, j) = VAL(a$)
NEXT i
NEXT j
drend:
CLOSE #1

END SUB

SUB DataWrite ()

ON ERROR GOTO ferror
IF RIGHT$(philer.dir1.path, 1) <> "\" THEN txt1$ = "\" ELSE txt1$ = ""
'f$ = philer.dir1.path + txt1$ + philer.text1.text
OPEN philer.dir1.path + txt1$ + philer.text1.text FOR OUTPUT AS #1
PRINT #1, "GRAPH 4"
PRINT #1, "ASCII"
PRINT #1, DATE$
PRINT #1, "?"
PRINT #1, VAL(cars1.rray(10).text) + 1
a$ = ""
FOR i = 0 TO VAL(cars1.rray(10).text)
a$ = a$ + LTRIM$(RTRIM$(cars1.rray(i).text)) + ","
NEXT i
a$ = LEFT$(a$, LEN(a$) - 1)    'trim trailing comma
PRINT #1, a$
a$ = ""
FOR i = 0 TO VAL(cars1.rray(10).text)
a$ = a$ + STR$(nopoints) + ","
NEXT i
a$ = LEFT$(a$, LEN(a$) - 1)    'trim trailing comma
PRINT #1, a$

FOR j = 1 TO nopoints
a$ = ""
FOR i = 0 TO VAL(cars1.rray(10).text)
a$ = a$ + RTRIM$(LTRIM$(STR$(b(i, j)))) + ","
NEXT i
a$ = LEFT$(a$, LEN(a$) - 1)    'trim trailing comma
PRINT #1, a$
NEXT j
CLOSE #1
END SUB

SUB DGPrep ()
IF cars1.graphv.value = 1 THEN
	   screen.HIDE
	   SCREEN vidmode
	   CLS
	   SELECT CASE UCASE$(cars1.rray(dxarray).text)
		 CASE "0"
			xstart = 0
			delx = shots / 500 * 1.1
			
		 CASE "WAVE"
		  
		  xstart = Henkan(gratingcounter + (-127 + rhett(258)) * stepix): delx = .021
		  delx = .021 * dir
		  IF contscan = 0 THEN
			CLS
			LOCATE 8, 24
			PRINT "cannot graph against wavelength with contscan off "
			INPUT x
			GOTO dgpexit
		  END IF
		 CASE "WVNO"
		  
		  xstart = Henkan(gratingcounter + (-127 + rhett(258)) * stepix)
		  xstart = 1 / (xstart):
		  xstart = xstart * 1E+07
		  delx = dir * .021 * (xstart) ^ 2
		  delx = delx * .0000001
		 CASE "RAMN"
		  
		  xstart = Henkan(gratingcounter + (-127 + rhett(258)) * stepix)
		  xstart = 1 / (xstart):
		  xstart = 1E+07 / xstart
		  xstart = (1E+07 / omega1) - xstart
		  delx = dir * .021 * (xstart) ^ 2
		  delx = -1 * delx * .0000001
		  IF contscan = 2 THEN delx = delx / 5


		 CASE ELSE
		 CLS
		 LOCATE 8, 24
		 PRINT "cannot graph against array "; xarray
		 INPUT x
		 GOTO dgpexit
	   END SELECT

VIEW (1, 1)-(514, 150), 0, 1
LOCATE 12, 1: PRINT LEFT$(STR$(xstart), 7)
LOCATE 12, 51: PRINT LEFT$(STR$(xstart + (nopoints * delx)), 7)

LOCATE 11, 59: PRINT vertmin
LOCATE 1, 59: PRINT vertmax
LOCATE 18, 59: PRINT "Current :"




	errorline = 116
 VIEW                                            'resets screen
 LINE (0, 197)-(517, 300), 1, B                  'draws mono box and crosshairs box
 LINE (258, 197)-(258, 190)
 LINE (258, 313)-(258, 302)

END IF

dgpexit:


END SUB

FUNCTION Estymate (wavechyaku)
IF wavechyaku > 640 THEN GOTO dropped
IF wavechyaku < 532 THEN GOTO dropped


i = gratingcounter                                         'starts with current position

DO WHILE ABS(wavechyaku - waveguessed) > .01                     'tries grating positions until nearest angstromm is reached

steps = i
waveguessed = Henkan(steps)
' waveguessed; wavechyaku
SELECT CASE waveguessed - wavechyaku
CASE IS > 0                           'guess is too big
i = i - 1
CASE IS < 0                           'guess is too small
i = i + 1
CASE ELSE
END SELECT
LOOP
Estymate = i                       'sets the step destination
dropped:
END FUNCTION

SUB EtalonControl (etalonword)

'etalonword = control word sent to etalon
'H305.4 - H305.7 = low byte H304.0 - H304.7 = high byte

FOR k = etbasho TO etalonword     'smooth movement to destination
low = k AND 15                  'calculate 4 lower bits
	high = (k - low) / 16           'calculate 8 higher bits and places them in 0-7 position
	OUT &H305, low * 16                'set lowbyte and place in 4-6 position
	OUT &H304, high                 'set highbyte
	FOR j = 1 TO 100: NEXT j        'allow time to set voltage
NEXT k
etbasho = etalonword
cars2.etbashov.text = STR$(etbasho)
etend:


END SUB

SUB EtCycle ()
'cycles etalon
CALL KaiteOku(0)
BEEP: LOCATE 19, 59: PRINT "Cycling etalon"
current = rhett(258)

SELECT CASE etbasho
CASE IS < 50
etalonword = etbasho + 3907
CASE IS > 4040
etalonword = etbasho - 3116
CASE ELSE
GOTO etcexit
END SELECT

CALL EtalonControl(etalonword)

DO UNTIL rhett(258) < current + 2 AND rhett(258) > current - 2
etalonword = etalonword + dir * 6
CALL EtalonControl(etalonword)
nankai = nando: firstpix = 0: lastpix = 255
CALL RetWindow(nankai, firstpix, lastpix)

'IF INKEY$ = CHR$(27) THEN GOTO etcexit

LOOP

CALL LyotCreep
CALL LyotCreep
etcexit:
 LOCATE 19, 59: PRINT "               "
ON ERROR GOTO 0
END SUB

SUB Etinc (su)
'su is the number of pixels to advance etalon.  -1 means advancement less than a reticon pixel width

SELECT CASE su
CASE -1
etalonword = etbasho + dir * emag1
CASE ELSE
etalonword = etbasho + dir * su
END SELECT

CALL EtalonControl(etalonword)                           'advance etalon

ON ERROR GOTO 0
END SUB

SUB ETSWP ()
CALL KaiteOku(0)

screen.HIDE

SCREEN vidmode

CLS                                      'draw monochromator box

 LINE (0, 197)-(517, 300), 1, B
 LINE (258, 197)-(258, 190)
 LINE (258, 313)-(258, 302)
			 'set upper viewport for intensity map
VIEW (1, 1)-(514, 150), 0, 1

LOCATE 12, 1: PRINT 0
LOCATE 12, 51: PRINT range


LOCATE 11, 59: PRINT 30
LOCATE 1, 59: PRINT 31
vertmin = 30: vertmax = 31

 nankai = nando                                     'poll reticon
 firstpix = 0: lastpix = 255
 CALL RetWindow(nankai, firstpix, lastpix)
 CALL Mado(firstpix, lastpix)

LOCATE 18, 16
FOR x = 1 TO 4095
etalonword = x
CALL EtalonControl(etalonword)

 nankai = nando                                     'poll reticon
 firstpix = 0: lastpix = 255
 CALL RetWindow(nankai, firstpix, lastpix)
 CALL Mado(firstpix, lastpix)

 'prepare to cut
	OUT &H30A, 64 + 1         'address channel 1
	jlow = INP(&H308)                       'get lower 8 bits
	jhigh = INP(&H309) AND 15               'get upper 4 bits
	jhigh = jhigh * 256             'shift the 4 bits left by 8 bits
 b(3, x) = jhigh + jlow      'make 16 bit integer, 2s complement
'cut







 b(0, x) = x

b(1, x) = rhett(258)
b(2, x) = rhett(256)
nopoints = x
cars1.nopointsv.text = STR$(x)

IF INKEY$ = CHR$(27) THEN GOTO owari2

 VIEW (2, 2)-(512, 148)
 erroline = 273                                    'autoscaling
 WINDOW (0, vertmin)-(4095, vertmax)
  errorline = 274
  SELECT CASE b(2, x)
  CASE IS > vertmax
  vertmax = b(2, x)
  CASE IS < vertmin
  vertmin = b(2, x)
  CASE ELSE
  GOTO et1
  END SELECT
   errorline = 321
  WINDOW (0, vertmin)-(4095, vertmax)
   errorline = 324
  CLS
  IF x < 2 THEN GOTO et1
  FOR sl = 1 TO x - 1:
  LINE (sl - 1, b(2, sl - 1))-(sl, b(2, sl)):
  NEXT sl
   errorline = 326
  LOCATE 1, 59: PRINT vertmax: LOCATE 11, 59: PRINT vertmin

et1:
IF x > 0 THEN LINE (x - 1, b(2, x - 1))-(x, b(2, x))






LOCATE 5, 5: PRINT x; "/ 4095"

NEXT x
owari2:

 SCREEN 0
 WIDTH 80
 screen.SHOW
CALL KaiteOku(0)

END SUB

SUB GratingControl (gratdir, gratmag)
'&h305,4 rotates clockwise   (00000100)
'&h305,8 rotates counterclockwise (00001000)
'gratingcounter:the running step number
'stepdelay: the time between individual grating queus

OUT &H305, 0 + (etbasho AND 15) * 16         '(etbasho and 15)*16 represents upper 4 bits of &h305 which goes to etalon, the  zero resets trigger just in case
FOR i = 1 TO gratmag
OUT &H305, gratdir + (etbasho AND 15) * 16         '(etbasho and 15)*16 represents upper 4 bits of &h305 which goes to etalon
tnaught = TIMER + stepdelay
DO WHILE TIMER < tnaught: LOOP

OUT &H305, 0 + (etbasho AND 15) * 16         '(etbasho and 15)*16 represents upper 4 bits of &h305 which goes to etalon


 IF cars4.updatescn.value = 0 THEN GOTO skippy
 SELECT CASE 1000 * INT(ABS(10 * (gratmag - i) / gratmag))
 CASE INT(ABS(10000 * (gratmag - i) / gratmag))
' firstpix = 0: lastpix = 255
' CALL RetWindow(1, firstpix, lastpix)
' CALL Mado(firstpix, lastpix)
 cars2.picture1.currenty = 1
 cars2.picture1.currentx = 1
 cars2.picture1.PRINT INT(100 - ABS(100 * (gratmag - i) / gratmag)); " % scanned  "
 CASE ELSE
 END SELECT
skippy:
'IF INKEY$ = CHR$(27) THEN
'trip = 1
'GOTO haltgt
'END IF

NEXT i



haltgt:

SELECT CASE gratdir                        'update grating counter index
 CASE IS = 8
  gratingcounter = gratingcounter + i
 CASE IS = 4
  gratingcounter = gratingcounter - i
 CASE ELSE
END SELECT

cars2.gcounterv.text = STR$(gratingcounter)

CALL KaiteOku(0)

GCexit:
END SUB

FUNCTION Henkan (steps)
'I don't like the final fit below, but will go with it for now
'in the future, must implement kigen and foundation to accomodate
'other calibration wavelengths.  As it stands, combo1 entries are
'ignored, and only HeNe calibration is allowed

'Henkan = (steps - kigen + foundation) * A1 + A2 * (steps - kigen + foundation) ^ 2 + A0
'Henkan = (steps - kigen + foundation) * A1 + A2 * (steps - kigen + foundation) ^ .99 + A0
 IF steps < 0 THEN steps = 0
 IF steps > 20000 THEN steps = 0

 Henkan = (steps) * A1 + A2 * ((steps) ^ .99) + A0



END FUNCTION

SUB Initialize ()
'this reads the initialization file for the variables corresponding to monochromator, lyot filter and etalon positoins

ierr = 0
ON ERROR GOTO initerror
CLS
OPEN "c:\cars.ini" FOR INPUT AS #1
IF ierr = 99 THEN GOTO iniexit

INPUT #1, a$
INPUT #1, gcounter
INPUT #1, a$
INPUT #1, lcounter
INPUT #1, a$
INPUT #1, etalonword
INPUT #1, a$
INPUT #1, x
aa$ = "Last w1 was " + STR$(x) + CHR$(13)
INPUT #1, a$
INPUT #1, x
aa$ = aa$ + "Last w2 was " + STR$(x) + CHR$(13)
INPUT #1, a$
INPUT #1, stepix
INPUT #1, a$
CLOSE #1

IF RTRIM$(LTRIM$(a$)) = "x" THEN ierr = 66

gratingcounter = gcounter
cars2.gcounterv.text = STR$(gcounter)
cars2.lcounterv.text = STR$(lcounter)
lyotcounter = lcounter
etbasho = etalonword
cars2.etbashov.text = STR$(etbasho)

iniexit:
SELECT CASE ierr
CASE 0
 MSGBOX aa$ + "POSITIONS ARE INITIALIZED"
 
CASE 99
 BEEP: BEEP
 MSGBOX aa$ + "POSITIONS ARE NOT INITIALIZED"
CASE 66
 MSGBOX aa$ + "CAUTION:  The initialization file indicates that" + CHR$(13) + "the program exited in an unusual manner the last time" + CHR$(13) + "it was run.  Initialized positions may be innaccurate."
 CASE ELSE
END SELECT


ierr = 0
ON ERROR GOTO 0

END SUB

SUB Kaihen ()
ON ERROR GOTO carserror
	CLS
	PRINT "grating steps ----> wavelength"
	INPUT "source array, target array"; ia, ib
	FOR i = 1 TO nopoints
	   
	b(ib, i) = Henkan(b(ia, i))
	NEXT i
	 'CALL MaxMin
	  
Kexit:  ON ERROR GOTO 0

END SUB

SUB Kaihen2 ()
ON ERROR GOTO carserror
	CLS
	PRINT "nanometers ----> wavenumbers"
	INPUT "source array, target array"; ia, ib
	FOR i = 1 TO nopoints
	IF b(ia, i) < .0001 THEN GOTO K2exit
	b(ib, i) = (1 / b(ia, i)) * 1E+07
	NEXT i
	 'CALL MaxMin
	 
K2exit:  ON ERROR GOTO 0

END SUB

SUB KaiteOku (gh)
'writes the position parameters in an initialization file

OPEN "c:\cars.ini" FOR OUTPUT AS #1
PRINT #1, "mono"
PRINT #1, gratingcounter
PRINT #1, "lyot"
PRINT #1, lyotcounter
PRINT #1, "etalon"
PRINT #1, etbasho
PRINT #1, "w1"
PRINT #1, omega1
PRINT #1, "w2"
PRINT #1, VAL(LEFT$(STR$(Henkan(gratingcounter + (-127 + rhett(258)) * stepix)), 7))
PRINT #1, "stepix"
PRINT #1, stepix
IF gh = 0 THEN
 PRINT #1, "x"
 ELSE PRINT #1, "i"
END IF
CLOSE #1
END SUB

SUB laser ()

CALL Etinc(-1)
odometer1 = odometer1 + emag1
odometer2 = odometer2 + emag1

IF odometer2 > emag2 THEN 'time to recenter lfilter
CALL LyotCreep
odometer2 = 0
END IF

IF odometer1 > efsr THEN 'time to recycle the etalon
etalonword = etbase
CALL EtalonControl(etalonword)
odometer1 = 0
END IF

lexit:
END SUB

SUB LyotControl (lyotdir, lyotmag)

'&h305,1 rotates clockwise --> increasing wavelength   (00000001)
'&h305,2 rotates counterclockwise     (00000010)

'lyotcounter:the running step number


OUT &H305, 0 + (etbasho AND 15) * 16           'resets trigger just in case, the upper 4 bits belong to the etalon, however, so let's maintain them
FOR i = 1 TO lyotmag
OUT &H305, lyotdir + (etbasho AND 15) * 16
tnaught = TIMER + stepdelay / 2
DO WHILE TIMER < tnaught: LOOP

OUT &H305, 0 + (etbasho AND 15) * 16         '(etbasho and 15)*16 represents upper 4 bits of &h305 which goes to etalon
NEXT i

SELECT CASE lyotdir                        'update grating counter index
 CASE IS = 2
  lyotcounter = lyotcounter - lyotmag

 CASE IS = 1
  lyotcounter = lyotcounter + lyotmag

 CASE ELSE
END SELECT

lcexit:
cars2.lcounterv.text = STR$(lyotcounter)

lc: END SUB

SUB LyotCreep ()
DIM ly(0 TO 4, 1 TO 3) AS INTEGER
DIM PPOS, LYPOS, AMP AS INTEGER
PPOS = 3: LYPOS = 1: AMP = 2


CALL RetWindow(10, 0, 255)
ly(0, PPOS) = rhett(258)
ly(0, LYPOS) = lyotcounter
ly(0, AMP) = rhett(256)' - rhett(257)
ly(4, AMP) = 0: LOST = 0

summit:

IF dir = 1 THEN lyotdir = 1
IF dir = -1 THEN lyotdir = 2
FOR kk = 1 TO 3: FOR kj = 1 TO 3: ly(kk, kj) = 0: NEXT kj: NEXT kk

'first reverse lyot filter by backpedal no of steps steps


lyotmag = backpedal
lyotdir = lyotdir + 1: IF lyotdir = 3 THEN lyotdir = 1   'reverse sense of direction

SELECT CASE marikata                                     'two tuning methods, fixed number of backward steps, or backup until intensity drops
 CASE 1: CALL LyotControl(lyotdir, lyotmag)
 CASE 2: DO UNTIL (rhett(ly(0, PPOS))) < .8 * ly(0, AMP):
	  CALL LyotControl(lyotdir, 1):
	   nankai = nando                             'number of times to sweep reticon
	   IF ly(0, PPOS) > 9 THEN firstpix = INT(ly(0, PPOS) - 5) ELSE firstpix = 0     'let's look at only the region near the peak
	   IF ly(0, PPOS) < 246 THEN lastpix = INT(ly(0, PPOS) + 5) ELSE lastpix = 255
	   CALL RetWindow(nankai, firstpix, lastpix)   'polls reticon
	  ' IF INKEY$ = CHR$(27) THEN GOTO lcrexit
		IF ABS(ly(1, PPOS) - ly(0, PPOS)) > 6 THEN
		 LOST = 1
		 GOTO lcrexit
		END IF
	 LOOP
 CASE 3: CALL LyotControl(lyodir, lyotmag)
 CASE ELSE
END SELECT

lyotdir = lyotdir + 1: IF lyotdir = 3 THEN lyotdir = 1   'restore sense of direction





'next take data
	ly(2, AMP) = 0                   'this is to trick the select case below into cycling twice

another:
'IF INKEY$ = CHR$(27) THEN GOTO lcrexit
   
	 CALL LyotControl(lyotdir, 1)
   
	 nankai = nando                             'number of times to sweep reticon
	 IF ly(0, PPOS) > 9 THEN firstpix = INT(ly(0, PPOS) - 5) ELSE firstpix = 0     'let's look at only the region near the peak
	 IF ly(0, PPOS) < 246 THEN lastpix = INT(ly(0, PPOS) + 5) ELSE lastpix = 255
   
	

	CALL RetWindow(nankai, firstpix, lastpix)   'polls reticon

	 ly(1, LYPOS) = lyotcounter                    'record intensity and postion of peak
	 ly(1, AMP) = rhett(ly(0, PPOS))                    'ly(j,k) j=1 current j=2 last j=PPOS max k=1 lyot postion k=2 peak position k=PPOS max pixel
	 ly(1, PPOS) = ly(0, PPOS)
   
	 IF ABS(ly(1, PPOS) - ly(0, PPOS)) > 6 THEN
	 LOST = 1
	 GOTO lcrexit
	 END IF
'so now we have the intensities for two adjacent steps.  Let's compare

	SELECT CASE ly(1, AMP)
	CASE IS > ly(2, AMP)
		  FOR k = 1 TO 3: ly(2, k) = ly(1, k): NEXT k
		  GOTO another
	CASE IS < ly(2, AMP)
		  FOR k = 1 TO 3: ly(3, k) = ly(1, k): ly(2, k) = ly(1, k): NEXT k
	CASE ELSE
		  GOTO another
	END SELECT


'let's take another step and compare to peak
yetanother:
'IF INKEY$ = CHR$(27) THEN GOTO lcrexit

	 IF ABS(ly(1, PPOS) - ly(0, PPOS)) > 6 THEN
	 LOST = 1
	 GOTO lcrexit
	 END IF

	 CALL LyotControl(lyotdir, 1)
   
	 nankai = nando                             'number of times to sweep reticon
	 IF ly(0, PPOS) > 9 THEN firstpix = INT(ly(0, PPOS) - 5) ELSE firstpix = 0     'let's look at only the region near the peak
	 IF ly(0, PPOS) < 246 THEN lastpix = INT(ly(0, PPOS) + 5) ELSE lastpix = 255

	CALL RetWindow(nankai, firstpix, lastpix)   'polls reticon
  '  CALL Mado(firstpix, lastpix)
	 ly(1, LYPOS) = lyotcounter                    'record intensity and postion of peak
	 ly(1, AMP) = rhett(ly(0, PPOS))                     'ly(j,k) j=1 current j=2 last j=3 max k=1 lyot postion k=2 peak position k=3 max pixel
	 ly(1, PPOS) = ly(0, PPOS)

	FOR k = 1 TO 3: ly(2, k) = ly(1, k): NEXT k

  
	SELECT CASE ly(1, AMP)
	CASE IS > ly(3, AMP)
		  GOTO another
	CASE IS < ly(3, AMP)
		  IF ly(1, AMP) > threshold * ly(3, AMP) THEN GOTO yetanother
	CASE ELSE
		  GOTO another
	END SELECT


	SELECT CASE ly(4, AMP)
	  CASE 0
	   FOR k = 1 TO 3: ly(4, k) = ly(1, k): NEXT k
	  lyotmag = lyotcounter - ly(0, LYPOS)                     'ly(0,1) original lyot position
		 SELECT CASE lyotmag
		  CASE IS < 0
		   lyotmag = ABS(lyotmag)
		   CALL LyotControl(1, lyotmag)
		   CALL LyotControl(1, lyotmag)
		   CALL LyotControl(2, lyotmag)
		  CASE IS > 0
		   CALL LyotControl(2, lyotmag)
		   CALL LyotControl(2, lyotmag)
		   CALL LyotControl(1, lyotmag)
		  CASE ELSE
		 END SELECT
	 
	   GOTO summit
   
	 CASE ELSE
	  SELECT CASE ly(4, PPOS)
	   CASE IS = ly(3, PPOS)
	   'ly(4,LYPOS) = INT((ly(4, AMP) * ly(4,LYPOS) + ly(3, AMP) * ly(3,LYPOS)) / (ly(4, AMP) + ly(3, AMP)))'ly(4,1_) is now the peak position of lyot filter
	   IF marikata <> 3 THEN ly(4, LYPOS) = INT((ly(4, LYPOS) + ly(3, LYPOS)) / 2)
	   CASE ELSE
	  END SELECT
	 END SELECT

	lyotmag = lyotcounter - ly(4, LYPOS)           'move lyotfilter to desired position
	  SELECT CASE lyotmag
	   CASE IS < 0
	lyotmag = ABS(lyotmag)
	CALL LyotControl(1, lyotmag)
	   CASE IS > 0
	CALL LyotControl(2, lyotmag)
	   CASE ELSE
	  END SELECT


lcrexit:

ON ERROR GOTO 0:

END SUB

SUB LYSWP ()
CALL KaiteOku(0)

range = VAL(INPUTBOX$("range in lyot steps "))
squish = VAL(INPUTBOX$("in leaps of how many steps "))
IF range > 4095 THEN range = 4095
range = INT(range / 2)
screen.HIDE

SCREEN vidmode

CLS                                      'draw monochromator box

 LINE (0, 197)-(517, 300), 1, B
 LINE (258, 197)-(258, 190)
 LINE (258, 313)-(258, 302)
			 'set upper viewport for intensity map
VIEW (1, 1)-(514, 150), 0, 1

LOCATE 12, 1: PRINT lyotcounter - range
LOCATE 12, 51: PRINT lyotcounter + range


LOCATE 11, 59: PRINT 30
LOCATE 1, 59: PRINT 31
vertmin = 30: vertmax = 31

 nankai = nando                                     'poll reticon
 firstpix = 0: lastpix = 255
 CALL RetWindow(nankai, firstpix, lastpix)
 CALL Mado(firstpix, lastpix)

LOCATE 18, 16
PRINT "Scanning from "; lyotcounter; " to "; lyotcounter - range
CALL LyotControl(2, range)                          'move to begining of range

FOR x = 1 TO INT(2 * range / squish)

FOR i = 1 TO squish

 CALL LyotControl(1, 1)

NEXT i

 nankai = nando                                     'poll reticon
 firstpix = 0: lastpix = 255
 CALL RetWindow(nankai, firstpix, lastpix)
 CALL Mado(firstpix, lastpix)

 b(0, x) = lyotcounter

b(1, x) = rhett(258)
b(2, x) = rhett(256)
nopoints = x
cars1.nopointsv.text = STR$(x)

IF INKEY$ = CHR$(27) THEN GOTO owari

 VIEW (2, 2)-(512, 148)
 erroline = 273                                    'autoscaling
 WINDOW (0, vertmin)-(2 * range, vertmax)
  errorline = 274
  SELECT CASE b(2, x)
  CASE IS > vertmax
  vertmax = b(2, x)
  CASE IS < vertmin
  vertmin = b(2, x)
  CASE ELSE
  GOTO t1
  END SELECT
   errorline = 321
  WINDOW (0, vertmin)-(2 * range, vertmax)
   errorline = 324
  CLS
  IF x < 2 THEN GOTO t1
  FOR sl = 1 TO x - 1:
  LINE (sl - 1, b(2, sl - 1))-(sl, b(2, sl)):
  NEXT sl
   errorline = 326
  LOCATE 1, 59: PRINT vertmax: LOCATE 11, 59: PRINT vertmin

t1:
IF x > 0 THEN LINE (x - 1, b(2, x - 1))-(x, b(2, x))






LOCATE 5, 5: PRINT x * squish; "/"; 2 * range

NEXT x

owari:

 SCREEN 0
 WIDTH 80
 screen.SHOW
CALL KaiteOku(0)


END SUB

SUB Mado (firstpix, lastpix)

'draws monochromator window, axes, labels and sets viewport

IF firstpix < 0 THEN firstpix = 0: IF lastpix > 255 THEN lastpix = 255



'print axes wavelengths
steps = gratingcounter + (-127 + firstpix) * stepix
LOCATE 23, 1: PRINT LEFT$(STR$(Henkan(steps)), 7)
steps = gratingcounter
LOCATE 23, 25: PRINT LEFT$(STR$(Henkan(steps)), 7)
steps = gratingcounter + (-127 + lastpix) * stepix
LOCATE 23, 50: PRINT LEFT$(STR$(Henkan(steps)), 7)


VIEW (3, 200)-(514, 297), 0                    'sets the graphics viewport


IF rhett(257) <> rhett(256) THEN

 WINDOW (firstpix, .9 * rhett(257))-(lastpix, 1.1 * rhett(256))
 FOR ii = firstpix TO lastpix
  PSET (ii, rhett(ii))
 NEXT ii

 LOCATE 22, 59: PRINT rhett(257)                     'prints the intensity of maximum pixel
 LOCATE 16, 59: PRINT rhett(256)                     'prints minimum intensity

steps = gratingcounter + (-127 + rhett(258)) * stepix
LOCATE 23, 70: PRINT LEFT$(STR$(Henkan(steps)), 7)








END IF

madoexit:

VIEW: WINDOW                                       'resets screen
END SUB

SUB March ()
'hoshihatyo is desired wavelength

CLS
				 
su = INT((hoshihatyo - Henkan(gratingcounter + (-127 + rhett(258)) * stepix)) / .021)


SELECT CASE su

 CASE IS > 0               'longer wavelength than current
  dir = 1:
 CASE IS < 0               'shorter wavelength than current
  dir = -1
 CASE ELSE
  GOTO marchexit

END SELECT

marchexit:
: ON ERROR GOTO 0
END SUB

SUB MonoGo ()
cars2.picture1.currenty = 3
cars2.picture1.currentx = 3
cars2.picture1.PRINT "Scanning from step "; gratingcounter; " to "; destination



gratmag = destination - gratingcounter
	   
  
SELECT CASE gratmag
  CASE IS < 0                           'destination is behind us
   gratmag = -1 * gratmag
   CALL GratingControl(4, gratmag)      'advance to destination

   CASE IS > 0                          'destination is ahead of us
   CALL GratingControl(8, gratmag)
   CASE ELSE
END SELECT
IF trip = 1 THEN GOTO mgexit
IF cars4.blash.value = 0 THEN GOTO mgexit 'skips backlash recovery
cars2.picture1.PRINT "Backlash Correction"
gratmag = 600
CALL GratingControl(4, gratmag)
cars2.picture1.PRINT "Backlash Correction"
CALL GratingControl(8, gratmag)                     'sets backlash to the right

mgexit:
trip = 0
END SUB

SUB MonoPrime ()

'first move the monochromator window so the peak is at an extreme


 SELECT CASE dir
  CASE 1
   destination = INT(gratingcounter + (235 - rhett(258)) * stepix)
  CASE -1
   destination = INT(gratingcounter - (rhett(258) - 20) * stepix)
  CASE ELSE
   GOTO mpexit
 END SELECT
 

CALL MonoGo

mpexit:
ON ERROR GOTO 0
END SUB

SUB PioInit ()

'Initialize all 8255s for i/o operation
'
' Initialization of 8-channel, 12 A/D converter using QuaTech board
'   send hex 92 to port hex 30b
	OUT &H30B, &H92
'initialization of QT board
	 OUT &H307, &H80
'turn off all shutters
	istatus = 255
	  OUT &H306, istatus
'initialize reticon interface thus:
'PIO control port, set up as port a = output, b = input, c = split
	   FOR i = 1 TO 4: OUT &H303, &H91: NEXT i
	  
'
ON ERROR GOTO 0:
END SUB

SUB ReadRC ()
IF RIGHT$(philer.dir1.path, 1) <> "\" THEN txt1$ = "\" ELSE txt1$ = ""

OPEN philer.dir1.path + txt1$ + philer.text1.text FOR INPUT AS #1

DO WHILE NOT EOF(1)
INPUT #1, txt1$
INPUT #1, txt2$
SELECT CASE txt1$
		CASE "rray0":  cars1.rray(0).text = txt2$
		CASE "rray1":  cars1.rray(1).text = txt2$
		CASE "rray2": cars1.rray(2).text = txt2$
		CASE "rray3": cars1.rray(3).text = txt2$
		CASE "rray4": cars1.rray(4).text = txt2$
		CASE "rray5": cars1.rray(5).text = txt2$
		CASE "rray6": cars1.rray(6).text = txt2$
		CASE "rray7": cars1.rray(7).text = txt2$
		CASE "rray8": cars1.rray(8).text = txt2$
		CASE "rray9": cars1.rray(9).text = txt2$
		CASE "rray10": cars1.rray(10).text = txt2$
	CASE "shotsv": cars1.shotsv.text = txt2$
	CASE "bkgv": cars1.bkgv.text = txt2$
	CASE "dyarrayv": cars1.dyarrayv.text = txt2$
	CASE "nopointsv": cars1.nopointsv.text = txt2$
	CASE "dxarrayv": cars1.dxarrayv.text = txt2$
		CASE "gcounter": cars2.gcounterv.text = txt2$
		CASE "lcounter": cars2.lcounterv.text = txt2$
		CASE "ulims1": Cars3.ulims(1).text = txt2$
		CASE "ulims2": Cars3.ulims(2).text = txt2$
		CASE "ulims3": Cars3.ulims(3).text = txt2$
		CASE "ulims4": Cars3.ulims(4).text = txt2$
		CASE "ulims5": Cars3.ulims(5).text = txt2$
		CASE "llims1": Cars3.llims(1).text = txt2$
		CASE "llims2": Cars3.llims(2).text = txt2$
		CASE "llims3": Cars3.llims(3).text = txt2$
		CASE "llims4": Cars3.llims(4).text = txt2$
		CASE "llims5": Cars3.llims(5).text = txt2$
	CASE "nandov": cars4.nandov.text = txt2$
	CASE "etpixv": cars4.etpixv.text = txt2$
	CASE "emag1": cars4.emag1v.text = txt2$
	CASE "emag2": cars4.emag2v.text = txt2$
	CASE "efsr": cars4.efsrv.text = txt2$
	CASE "thresholdv": cars4.thresholdv.text = txt2$
	CASE "stepdelayv": cars4.stepdelayv.text = txt2$
	CASE "kigenv": cars4.kigenv.text = txt2$
	CASE "stepixv": cars4.stepixv.text = txt2$
	CASE "calwavepos": cars4.combo1.listindex = VAL(txt2$)
	CASE "A1": cars4.A1v.text = txt2$
	CASE "A2": cars4.A2v.text = txt2$
	CASE "A0": cars4.A0v.text = txt2$
	CASE "retdelayv": cars4.retdelayv.text = txt2$
	CASE ELSE
	END SELECT
LOOP
CLOSE #1

END SUB

SUB RepScan ()
ON ERROR GOTO carserror
CLS
LOST = 0


SCREEN VC.Scrn
VIEW (1, 1)-(514, 150), 0, 1

LOCATE 2, 2: INPUT "number of repetitions", x

CALL ArrayAllot

FOR j = 1 TO x
VIEW (2, 2)-(512, 148)
WINDOW (0, 0)-(4095, 4095)
CLS
LOCATE 2, 8: PRINT "rep "; j
may1 = 0
may2 = 0
may3 = 0
max1 = 0
max2 = 0
max3 = 0

FOR i = 1 TO 4095
etalonword = i
CALL EtalonControl(etalonword): ON ERROR GOTO carserror
CALL SHdata(0): ON ERROR GOTO carserror

IF LOST = 2 THEN GOTO rsexit
IF i > 1 THEN
LINE (i - 1, toshyori)-(i, tran(1))
toshyori = tran(1)
END IF


IF tran(1) > max1 THEN
max1 = tran(1)
max2 = i
END IF

SELECT CASE tran(1)
CASE IS < .2 * max1
   IF may1 = 0 THEN
   may1 = max2
   max1 = 0
   GOTO pop
   END IF

   IF may2 = 0 THEN
   may2 = max2
   max1 = 0
   GOTO pop
   END IF

   IF may3 = 0 THEN
   may3 = max2
   max1 = 0
   GOTO pop
   END IF

CASE ELSE
END SELECT
pop:


NEXT i
errorline = 49
b(0, j) = j
b(1, j) = may1
b(2, j) = may2
b(3, j) = may3

nopoints = j
cars1.nopointsv.text = STR$(j)

IF INKEY$ = CHR$(27) THEN GOTO rsexit

 LINE (may1, 0)-(may1, 4095)
 LINE (may2, 0)-(may2, 4095)
 LINE (may3, 0)-(may3, 4095)



FOR i = 4095 TO 1 STEP -1
etalonword = i
CALL EtalonControl(etalonword)
NEXT i



NEXT j














rsexit:



END SUB

SUB RetWindow (nankai, firstpix, lastpix)
'firstpix = first pixel to scan, lastpix = last pixel to scan
'
IF firstpix < 0 THEN firstpix = 0: IF lastpix > 255 THEN lastpix = 255
rhett(256) = 0: rhett(257) = 255                      '256th and 257th entries are max and min of array

k = INP(&H302)
k = k AND 3

	SELECT CASE k
		CASE 1  'currently bank A (1) so request new data from bank B
			kbankreq = 2
		CASE ELSE  'currently bank B (2) so request new data from bank A
			kbankreq = 1
	 END SELECT

FOR konokai = 1 TO nankai          'konokai =dummy counter, nankai = number of scans to average

rreq:
	SELECT CASE kbankreq
	CASE 2: kcode = 1
	CASE 1: kcode = 2
	CASE ELSE:
	END SELECT
	
	kcode = 64 * (kcode)  'get proper hex code
				'for this board (on IBM AT)
				'bit 7 is req. A
				'bit 6 is req. B

	FOR i = 1 TO 2: OUT &H302, kcode: NEXT i

'poll the bank status

	in = 0
rtrpol:
	k = INP(&H302)
	k = k AND kbankreq
	in = in + 1
	IF in > 10000 THEN BEEP: GOTO rwend
	IF k = 0 THEN GOTO rtrpol                       'bank is busy, try again



'test for bankswitch override options on menu 4
IF cars4.bankoption(1).value = -1 AND kbankreq = 2 THEN kbankreq = 1: GOTO rreq
IF cars4.bankoption(2).value = -1 AND kbankreq = 1 THEN kbankreq = 2: GOTO rreq



'read 256 channels

		FOR i = lastpix TO firstpix STEP -1                   'let's poll backwards to sweep over sharp edge first
		FOR kk = 1 TO retdelay: OUT &H301, i: NEXT kk         'delay , address ith pixel

		IF konokai = 1 THEN
		  rhett(i) = 0                                          'resets data in the array if first sweep
		END IF

		  rhett(i) = INP(&H300) + rhett(i)                      'read the pixel

		IF konokai = nankai THEN                                   'the last sweep so average
		  rhett(i) = rhett(i) / nankai                           'average over number of sweeps
		  IF i < 7 THEN rhett(i) = rhett(257)                    'first 6 pixels are damaged, so set to minimum
		  IF rhett(i) > rhett(256) THEN rhett(256) = rhett(i): rhett(258) = i              '256 = max; 257 = min 258 = max channel no.
		  IF rhett(i) < rhett(257) THEN rhett(257) = rhett(i)
		END IF

	NEXT i

	IF kbankreq = 1 THEN kbankreq = 2 ELSE kbankreq = 1
NEXT konokai
rwend:

 END SUB

SUB ScanBackground (kcon)
'kcon = 0 is normal background, kcon = 1 gives cars multiple backrounds



'
'--- take background data for all channels used in Scan routine -------------
	
'turn reference , input shutters on
	  CALL Solenoids(0, 1): CALL Solenoids(1, 1): CALL Solenoids(2, 1): ON ERROR GOTO carserror
'delay for shutters
	   otime = TIMER: DO WHILE (TIMER - otime) < 1: LOOP


' data loop - take data shots times and average
	FOR i = 1 TO 5: bkg(i) = 0: NEXT i
	   
	FOR j = 1 TO shots:
	 CALL ADconv(intrup): ON ERROR GOTO carserror
	  FOR i = 1 TO 5
	   bkg(i) = bkg(i) + rawdata(i)
	  NEXT i
	NEXT j
	   
	FOR i = 1 TO 5
	bkg(i) = bkg(i) / shots
	NEXT i
' end data loop

'clear background from specified channels
'
'turn reference shutters off
	CALL Solenoids(1, 0): CALL Solenoids(2, 0): ON ERROR GOTO carserror
'delay for shutters
	   otime = TIMER: DO WHILE (TIMER - otime) < 1: LOOP

IF kcon = 0 THEN GOTO sbexit                      'standard background checkings








'
'ok, that measures the electronic background, now lets address the scattering
'one by one

'CAUTION:  The remainder assumes that Iw3 is at hardchannel 1, Iw1 is at hardchannel 2 and Iw2 is at hardcchannel 3
'          It will uitilize upper portions of the array bkg(i) not ordinarily addressed
'           Here's how:
'                       bkg(8) = ambient background on w2 reference (caused by w1)
'                       bkg(9) = ambient background on w1 reference (caused by w2)
'                       bkg(10) = background on pmt due to w1 alone (caused by w1)
'                       bkg(11) = background on pmt due to w2 alone (caused by w2)
'                       bkg(12) = proportionality factor between intensity of w1 and
'                                 the background it causes on pmt, i.e. bkg(10) = bkg(12) * Iw1
'                       bkg(13) = proportionality factor between intensity of w2 and
'                                 the background it causes on pmt, i.e. bkg(11) = bkg(13) * Iw2

	  
	FOR i = 8 TO 13: bkg(i) = 0: NEXT i              'clear these positions
	 



'first we'll trip shutter 2 and release shutter 1, thus scattering w1 only (yellow)
	 
  CALL Solenoids(1, 0): CALL Solenoids(2, 1): ON ERROR GOTO carserror

'delay for shutters
	   otime = TIMER: DO WHILE (TIMER - otime) < 1: LOOP


' data loop - take data shots times and average
	FOR j = 1 TO shots:
	 CALL ADconv(intrup): ON ERROR GOTO carserror
	   bkg(8) = bkg(8) + rawdata(3) - bkg(3)
	   bkg(10) = bkg(10) + rawdata(1) - bkg(1)
	NEXT j
	   bkg(8) = bkg(8) / shots
	   bkg(10) = bkg(10) / shots
' end data loop



'next we'll trip shutter 1 and release shutter 2, thus scattering only w2 (orange)


  CALL Solenoids(1, 1): CALL Solenoids(2, 0): ON ERROR GOTO carserror

'delay for shutters
	   otime = TIMER: DO WHILE (TIMER - otime) < 1: LOOP


' data loop - take data shots times and average
	FOR j = 1 TO shots:
	 CALL ADconv(intrup): ON ERROR GOTO carserror
	   bkg(9) = bkg(9) + rawdata(2) - bkg(2)
	   bkg(11) = bkg(11) + rawdata(1) - bkg(1)
	NEXT j
	  
	   bkg(9) = bkg(9) / shots
	   bkg(11) = bkg(11) / shots
' end data loop


'turn reference shutters off
	CALL Solenoids(1, 0): CALL Solenoids(2, 0): ON ERROR GOTO carserror
'delay for shutters
	   otime = TIMER: DO WHILE (TIMER - otime) < 1: LOOP


	   
'now let's grab the  tiger by the tail

' data loop - take data shots times and average
	FOR j = 1 TO shots:
	 CALL ADconv(intrup): ON ERROR GOTO carserror
	   bkg(13) = bkg(13) + (bkg(11)) / (rawdata(3) - bkg(3))
	   bkg(12) = bkg(12) + (bkg(10)) / (rawdata(2) - bkg(2))
	NEXT j
	   bkg(13) = bkg(13) / shots
	   bkg(12) = bkg(12) / shots


'NOTE:  as of 7/9/93 the references cross backrounds were not implemented
'        that is, the alpha's (see blue notes).  Only the beta's are implemented.


















'
sbexit:  ON ERROR GOTO 0

sb:       END SUB

SUB SHdata (intrup)
'
'fast SH data accumulation, data=signal/reference
'I assume that the signals vary from 0V (0) to 10V (4096)

'set variables
	ierr = 0:
	FOR i = 0 TO 9: tran(i) = 0: NEXT i 'accumulate data here
	iunder = 0: iover = 0   'counters fo data too low and high


'take data shots times
	   
	FOR j = 1 TO shots
		  intrup$ = INKEY$
		  IF intrup$ = CHR$(27) THEN
		  LOST = 2
		  GOTO sintad
		  END IF

'
'wait for laser to fire and eoc on all A/D converters
	OUT &H30A, 64: OUT &H30A, 0: OUT &H30A, 64  'reset trigger flip-flop
sh1:    IF (INP(&H309) AND 128) = 0 THEN GOTO sh1  'check for eoc on all ADs



'Read selected channels for this laser shot
'
'  accumulate data for specified number of channels
	   
	FOR i = 1 TO 5
'  select the channel
	OUT &H30A, 64 + i         'address channel 1 to 5
'  read 12 bit data
	jlow = INP(&H308)                       'get lower 8 bits
	jhigh = INP(&H309) AND 15               'get upper 4 bits
	jhigh = jhigh * 256             'shift the 4 bits left by 8 bits
'the next two lines are used only for bipolar operation
'        IF (jhigh AND 2048) = 0 THEN GOTO sposad 'check for positive number
'        jhigh = jhigh OR -4096          'neg number so set high bits to 1
sposad: rawdata(i) = jhigh + jlow       'make 16 bit integer, 2s complement
			   
			IF rawdata(i) > highlim(i) THEN       'reject shot if low or high
				iover = iover + 1
				j = j - 1
				GOTO mrdt
			END IF
			IF rawdata(i) < lowlim(i) THEN
				iunder = iunder + 1
				j = j - 1
				GOTO mrdt
			END IF
	rawdata(i) = rawdata(i) - bkg(i)     'remove background
	  
	IF rawdata(i) < 1E-08 THEN
			iunder = iunder + 1
			j = j - 1
			GOTO mrdt
	END IF
	   
	NEXT i


'CARS SPECIFIC LINE
	   rawdata(1) = rawdata(1) - bkg(12) * rawdata(2) - bkg(13) * rawdata(3)
erroline = 38
'
'   End of channel read cycle

hell:   FOR i = 0 TO noarrays
	SELECT CASE rrayop(i, 0)
		CASE 1
		 tran(i) = tran(i) + rawdata(rrayop(i, 1))
		CASE 2
		 IF rawdata(rrayop(i, 2)) < 1E-08 THEN GOTO sintad
		 tran(i) = tran(i) + rawdata(rrayop(i, 1)) / rawdata(rrayop(i, 2))
		CASE 5
		 IF rawdata(rrayop(1, 2)) < 1E-08 THEN GOTO sintad
		 IF rawdata(rrayop(1, 3)) < 1E-08 THEN GOTO sintad
		 tran(i) = tran(i) + rawdata(rrayop(i, 1)) / rawdata(rrayop(i, 2)) / rawdata(rrayop(i, 3))
		CASE 4
		 IF rawdata(rrayop(1, 2)) < 1E-08 THEN GOTO sintad
		 IF rawdata(rrayop(1, 3)) < 1E-08 THEN GOTO sintad
		 IF rawdata(rrayop(1, 4)) < 1E-08 THEN GOTO sintad
		 tran(i) = tran(i) + rawdata(rrayop(i, 1)) / rawdata(rrayop(i, 2)) / rawdata(rrayop(i, 3)) / rawdata(rrayop(i, 4))
		CASE ELSE
	END SELECT
	   
	NEXT i

	IF ierr = 1 THEN GOTO sintad
mrdt:
NEXT j

'all shots have been added, now for averaging
'and special operations


FOR i = 0 TO noarrays:
tran(i) = tran(i) / shots           'average
	
	 IF rrayop(i, 0) = -1 THEN
	  SELECT CASE rrayop(i, 1)
	   CASE 1                     'wavelength array
			tran(i) = Henkan(gratingcounter + (-127 + rhett(258) + dir * kowashi * 8 / etpix) * stepix)
	   CASE 2
			tran(i) = Henkan(gratingcounter + (-127 + rhett(258) + dir * kowashi * 8 / etpix) * stepix)
			tran(i) = 1 / (tran(i))
			tran(i) = 1E+07 * tran(i)
	   CASE 3       'Raman Shift array
	   
			tran(i) = Henkan(gratingcounter + (-127 + rhett(258) + dir * kowashi * 8 / etpix) * stepix)
			tran(i) = 1 / (tran(i))
			tran(i) = 1E+07 * tran(i)
			tran(i) = (1E+07 / omega1) - tran(i)
	  CASE 4      'time array
tran(i) = TIMER
IF tran(i) < otime THEN tran(i) = tran(i) + 86400 'run through midnight
tran(i) = tran(i) - otime

	  CASE ELSE
	  END SELECT
	 END IF

NEXT i
'
	   
	GOTO shexit

sintad: intrup = 1: LOCATE 5, 2: PRINT "Interrupt in SHData.";


shexit: ON ERROR GOTO 0
END SUB

SUB Skan ()


'
errorline = 11

 FOR i = 1 TO 5: bkg(i) = 0: NEXT i
 CALL KaiteOku(0)               'write laser positions to .ini file in case of crash
 CALL ArrayAllot                'set up data arrays
 CALL DGPrep                    'set up data plotting
 otime = TIMER                  'initialize timer
	FOR i = 1 TO nopoints

'take background every bkfactor number of points
IF bkfactor = 0 THEN GOTO s12          'no background checking at all
	SELECT CASE i
	 CASE 0:
	 CALL ScanBackground(1)
	 lastbackground = 0
	 CASE bkfactor + lastbackground
	  lastbackground = i
	  CALL ScanBackground(1)
	 CASE ELSE
   END SELECT

s12:

CALL laser
CALL SHdata(intrup):

IF iover > 0 OR iunder > 0 THEN
	 LOCATE 25, 11, 0: PRINT CHR$(24); over;
	 LOCATE 25, 28, 0: PRINT CHR$(25); under;
END IF

'load the arrays with data

FOR j = 0 TO noarrays
b(j, i) = tran(j)
NEXT j



'display data

IF cars1.graphv.value = 1 THEN

 VIEW (2, 2)-(512, 148)
  SELECT CASE b(dyarray, i)
  CASE IS > vertmax
  vertmax = b(dyarray, i)
  CASE IS < vertmin
  vertmin = b(dyarray, i)
  CASE ELSE
  WINDOW (0, vertmin)-(nopoints, vertmax)
  GOTO ss1
  END SELECT
  WINDOW (0, vertmin)-(nopoints, vertmax)


  CLS
  IF i < 2 THEN GOTO ss1
  FOR sl = 1 TO i - 1:
  LINE (sl - 1, b(dyarray, sl - 1))-(sl, b(dyarray, sl)):
  NEXT sl
   errorline = 326
  LOCATE 1, 59: PRINT vertmax: LOCATE 11, 59: PRINT vertmin

ss1:

IF i > 0 THEN LINE (i - 1, b(dyarray, i - 1))-(i, b(dyarray, i))

END IF

IF INKEY$ = CHR$(27) THEN GOTO sexit

NEXT i

' end data loop
sexit:
INPUT x
IF cars1.graphv.value = 1 THEN
SCREEN 0
WIDTH 80
screen.SHOW
END IF




END SUB

SUB Solenoids (inoid, ionoroff)



'There are 6 solenoids available (0 to 5) !!
	IF inoid < 0 OR inoid > 5 THEN GOTO slexit
	IF ionoroff = 1 THEN
		istatus = istatus AND (NOT 2 ^ inoid)
	ELSE istatus = istatus OR 2 ^ inoid
	END IF
		OUT &H306, istatus

slexit: ON ERROR GOTO 0
END SUB

SUB vidcheck ()
ON LOCAL ERROR GOTO vidchecked
screen.HIDE
vidmode = 12
vmx = 639: vmy = 479
SCREEN vidmode
GOTO viddone
vidchecked:
vidmode = 3
vmx = 719: vmy = 347
RESUME
viddone:
ON ERROR GOTO 0
SCREEN 0
WIDTH 80
screen.SHOW
END SUB

SUB WriteRC ()
IF RIGHT$(philer.dir1.path, 1) <> "\" THEN txt1$ = "\" ELSE txt1$ = ""

OPEN philer.dir1.path + txt1$ + philer.text1.text FOR OUTPUT AS #1
		PRINT #1, "rray0" + "," + cars1.rray(0).text
		PRINT #1, "rray1" + "," + cars1.rray(1).text
		PRINT #1, "rray2" + "," + cars1.rray(2).text
		PRINT #1, "rray3" + "," + cars1.rray(3).text
		PRINT #1, "rray4" + "," + cars1.rray(4).text
		PRINT #1, "rray5" + "," + cars1.rray(5).text
		PRINT #1, "rray" + "," + cars1.rray(6).text
		PRINT #1, "rray7" + "," + cars1.rray(7).text
		PRINT #1, "rray8" + "," + cars1.rray(8).text
		PRINT #1, "rray9" + "," + cars1.rray(9).text
		PRINT #1, "rray10" + "," + cars1.rray(10).text
	PRINT #1, "shotsv" + "," + cars1.shotsv.text
	PRINT #1, "bkgv" + "," + cars1.bkgv.text
	PRINT #1, "dyarrayv" + "," + cars1.dyarrayv.text
	PRINT #1, "nopointsv" + "," + cars1.nopointsv.text
	PRINT #1, "dxarrayv" + "," + cars1.dxarrayv.text
		PRINT #1, "gcounter" + "," + cars2.gcounterv.text
		PRINT #1, "lcounter" + "," + cars2.lcounterv.text
		PRINT #1, "ulims1" + "," + Cars3.ulims(1).text
		PRINT #1, "ulims2" + "," + Cars3.ulims(2).text
		PRINT #1, "ulims3" + "," + Cars3.ulims(3).text
		PRINT #1, "ulims4" + "," + Cars3.ulims(4).text
		PRINT #1, "ulims5" + "," + Cars3.ulims(5).text
		PRINT #1, "llims1" + "," + Cars3.llims(1).text
		PRINT #1, "llims2" + "," + Cars3.llims(2).text
		PRINT #1, "llims3" + "," + Cars3.llims(3).text
		PRINT #1, "llims4" + "," + Cars3.llims(4).text
		PRINT #1, "llims5" + "," + Cars3.llims(5).text
	PRINT #1, "nandov" + "," + cars4.nandov.text
	PRINT #1, "etpixv" + "," + cars4.etpixv.text
	PRINT #1, "emag1" + "," + cars4.emag1v.text
	PRINT #1, "emag2" + "," + cars4.emag2v.text
	PRINT #1, "efsr" + "," + cars4.efsrv.text
	PRINT #1, "thresholdv" + "," + cars4.thresholdv.text
	PRINT #1, "stepdelayv" + "," + cars4.stepdelayv.text
	PRINT #1, "kigenv" + "," + cars4.kigenv.text
	PRINT #1, "stepixv" + "," + cars4.stepixv.text
	PRINT #1, "calwavepos" + "," + STR$(cars4.combo1.listindex)
	PRINT #1, "A1" + "," + cars4.A1v.text
	PRINT #1, "A2" + "," + cars4.A2v.text
	PRINT #1, "A0" + "," + cars4.A0v.text
	PRINT #1, "retdelayv" + "," + cars4.retdelayv.text
CLOSE #1


END SUB

